/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.thin.tutorial.web.action;

import jp.terasoluna.fw.service.thin.BLogicMessage;
import jp.terasoluna.fw.service.thin.BLogicMessages;
import jp.terasoluna.fw.service.thin.BLogicResult;
import jp.terasoluna.fw.web.struts.actions.AbstractBLogicAction;
import jp.terasoluna.thin.tutorial.service.bean.UserBean;
import jp.terasoluna.thin.tutorial.service.blogic.DeleteBLogic;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.Globals;

/**
 * 情報削除アクション。
 *
 * 削除を行うビジネスロジックを呼び、データベースの情報を削除する。
 *
 */
public class DeleteAction extends AbstractBLogicAction<UserBean> {

    /**
     * ログクラス。
     */
    private Log log = LogFactory.getLog(DeleteAction.class);

    /**
     * 実行するビジネスロジッククラス。
     */
    private DeleteBLogic deleteBLogic = null;

    /**
     * ビジネスロジックを返却する。
     *
     * @return 保持するビジネスロジック
     */
    public DeleteBLogic getDeleteBLogic() {
        return deleteBLogic;
    }

    /**
     * ビジネスロジックを設定する。
     *
     * @param deleteBLogic ビジネスロジック
     */
    public void setDeleteBLogic(DeleteBLogic deleteBLogic) {
        this.deleteBLogic = deleteBLogic;
    }

    /**
     * ビジネスロジックを実行し、結果を返却する。
     *
     * @param bean 削除対象のユーザIDの値を保持したbean
     * @return 登録結果を保持したBLogicResult
     * @throws Exception 例外
     */
    @Override
    public BLogicResult doExecuteBLogic(UserBean bean) throws Exception {

        if (log.isDebugEnabled()) {
            log.debug("doExecuteBLogic Start.");
        }

        //ビジネスロジックの実行、結果の取得
        int i = deleteBLogic.delete(bean);

        //BLogicResultの生成、結果の設定
        BLogicResult result = new BLogicResult();
        result.setResultString("success");

        //結果件数が0以下の場合は登録できなかったとして、
        //エラーメッセージを設定する。
        if (i <= 0) {
            BLogicMessages errors = result.getErrors();
            if (errors == null) {
                errors = new BLogicMessages();
            }
            errors.add(Globals.ERROR_KEY, new BLogicMessage("error.no.delete"));
            result.setErrors(errors);
        }

        return result;
    }

}